use std::io::Write;

fn main() {
    //println!("cargo:rerun-if-env-changed=PLATFORM");

    if std::env::var("TARGET").unwrap().contains("riscv64") {
        let board = std::env::var("PLATFORM").unwrap();
        let kernel_base_addr: u64 = if board.contains("d1") {
            0xffffffffc0100000
        } else {
            // opensbi仍旧把kernel放在0x80200000物理内存中
            0xffffffff80200000
        };

        let mut fout = std::fs::File::create("src/platform/riscv/boot/kernel-vars.ld").unwrap();
        writeln!(fout, "/* Generated by build.rs. DO NOT EDIT. */").unwrap();
        writeln!(
            fout,
            "PROVIDE_HIDDEN(BASE_ADDRESS = {:#x});",
            kernel_base_addr
        )
        .unwrap();
    }
}
